echo off

:top
cls
echo !
echo ! ACTRPT - System Activity Report Generator v1.1 (2/2/87 SHS)
echo !

askyn ! Do you want a standard system activity report
if errorlevel 1 goto standard

echo !
echo ! Do you want a system activity report that includes lines for
askyn ! commands executed only once
if errorlevel 1 goto detail

echo !
askyn ! Do you want a system activity report without the I/O counts
if errorlevel 1 goto noio

echo !
echo ! Do you want to replace the activity log with a summary
askyn ! of it's current contents
if errorlevel 1 goto summary
goto another


:summary
echo !
echo ! Generating summary data...
sort <c:\sysact.log | safmt -s >activity.sum
echo !     Activity Summary written to ACTIVITY.SUM
copy c:\sysact.log sysact.old >nul
echo !     Old activity log copied to SYSACT.OLD
copy activity.sum c:\sysact.log
echo !     Activity log replaced with summary data.
goto another


:noio
echo !
echo ! Generating activity report... (without I/O counts)
sort <c:\sysact.log | safmt -j -i >activity.cmd
echo !     Activity by Command Name   written to ACTIVITY.CMD
sort /+23 /r <activity.cmd >activity.num
echo !     Activity by Number of Runs written to ACTIVITY.NUM
sort /r <activity.cmd >activity.tim
echo !     Activity by Total Time     written to ACTIVITY.TIM
echo !
goto output


:detail
echo !
echo ! Generating activity report... (with single run details)
sort <c:\sysact.log | safmt >activity.cmd
echo !     Activity by Command Name   written to ACTIVITY.CMD
goto continue

:standard
echo !
echo ! Generating activity report... (standard)
sort <c:\sysact.log | safmt -j >activity.cmd
echo !     Activity by Command Name   written to ACTIVITY.CMD

:continue
sort /+48 /r <activity.cmd >activity.num
echo !     Activity by Number of Runs written to ACTIVITY.NUM
sort      /r <activity.cmd >activity.tim
echo !     Activity by Total Time     written to ACTIVITY.TIM
echo !


:output
askyn ! Output report to the screen
if errorlevel 1 goto toscreen
askyn ! Output report to the printer
if errorlevel 1 goto toprint
goto another


:toscreen
cls
more <activity.cmd
pause
cls
more <activity.num
pause
cls
more <activity.tim
goto another


:toprint
echo  System Activity Report:     SORTED BY COMMAND >prn
type activity.cmd >prn

echo  System Activity Report:     SORTED BY NUMBER OF RUNS >prn
type activity.num >prn

echo  System Activity Report:     SORTED BY TOTAL TIME >prn
type activity.tim >prn
goto another


:another
echo !
askyn ! Do you want to run another activity report
if errorlevel 1 goto top

:end
echo !
echo ! Returning to DOS.
echo !
