echo off
cls
echo       ([m)    HELPEM help screen system demonstration
echo 
echo 
echo If any characters are shown between the
echo above brackets then the ANSI screen handler is NOT installed.
echo This demonstration (but not HELPEM) requires that ANSI.SYS is
echo present and active, if it is not then please install it and
echo restart your system.
echo Consult your computer user manual if you are not sure how to
echo do this.
echo 

echo This demonstration will involve the installation of HELPEM,
echo certain other TSR programs need to be the last ones to be installed
echo and so we recommend that you de-install any existing TSR programs
echo before continuing this demonstration.
echo 
echo Also, check that COMMAND.COM is in the current directory, or
echo in the directory search path.

echo 
echo do you wish to continue with the demonstration (Y/N)
getchar
if errorlevel 89 if not errorlevel 90 goto go1
if errorlevel 121 if not errorlevel 122 goto go1
goto end

:go1
echo [=3h
echo [1;37;44m
echo [2J
echo             HELPEM help system demonstration
echo 

echo This demonstration is an MSDOS batch file, as such it does
echo not execute particularly quickly. When integrated into your own
echo programs (which can be written in any language) HELPEM
echo pops up a help screen instantly. When the user has finished
echo the help screen vanishes instantly, to be replaced by the
echo original sreen display.
echo 
echo Press any key to see a typical installation of HELPEM

getchar
cls
echo 
type h1
echo 
command /c HELPEM <DEMO.HLP 3 1788

echo 

echo Helpem is now installed, here is an explanation of the above
echo command. The file DEMO.HLP is the source of the help text,
echo you will write your own when you come to use HELPEM in your
echo applications. This file has been loaded into memory.

echo 
echo The 3 means that the help screen will be activated by pressing
echo the Alt and F3 together.
echo 

echo The number 1788 means that the screen "hot-zone" will start at
echo row 23 column 29, 0 would be top left and 2000 would be bottom
echo right. This is the feature exclusive to HELPEM that makes it so
echo useful, HELPEM communicates with your own programs via the screen
echo hot zone.
echo 

echo Press any key for an explanation of hot-zones

getchar
cls
echo The screen hot zone is an area of the screen where HELPEM expects
echo to find a help page number, press a key to see where position
echo 1788 is.

getchar
echo 
echo [s
echo [23;2HHere is the hot zone  
echo [23;29H[42;30m    [37;44m  corresponding to position 1788
echo [uThe next step is to place a page number into the hot zone,
echo press a key to see this.

getchar
echo 
echo [s
echo [23;29H[42;30m1
echo [u[37;44mWe are now set up to display help page 1. All that is required
echo of programs you write is that a page number be placed at the
echo hot zone position defined at HELPEM installation time.
echo 

:go3
echo [14;1HNow press Alt and F3 together to see help screen 3
getchar
if errorlevel 106 if not errorlevel 107 goto go4
echo [15;1HTry again, you must press the Alt and F3 keys together
goto go3

:go4
rem help screen now up front, tells viewer to press a key
rem now trap the char pressed to exit help

getchar
echo [15;1H[K
echo The next section will show how a typical application program
echo might appear when set up to use the HELPEM system
echo 
echo Press a key to continue
:again
getchar
rem prevent exit while help screen showing
if errorlevel 106 if not errorlevel 107 goto again

:go5
echo [0;30;47m
cls
echo 
echo          ͻ
echo            Inscrutable Program   V1.0  Main menu   
echo          ͼ
echo 
echo 
echo              ͻ
echo                1        BUDGETS
echo              ͼ
echo 
echo              ͻ
echo                2        FORECASTS
echo              ͼ
echo 
echo              ͻ
echo                3        COMMUNICATIONS
echo              ͼ
echo 
echo              ͻ
echo                4        QUIT (to next part of demo)
echo              ͼ
echo 

echo  PRESS Alt-F3 FOR HELP PAGE
echo [23;29H[1;41;37m2   [0;30;47m      OR CHOOSE AN OPTION
:go7
getchar
if errorlevel 53 goto go7
if errorlevel 52 goto go6
if errorlevel 51 goto com
if errorlevel 50 goto for
if errorlevel 49 goto bud
goto go7



:for
echo [1;37;42m
cls
echo 

echo          ͻ
echo            Inscrutable Program   V1.0  Forecast menu  
echo          ͼ
echo 
echo 
echo 

echo                   ͻ
echo                     Forecast functions menu  
echo                   ͼ
echo 
echo 
echo 

echo          ͻ
echo                                                    
echo             PRESS X  TO RETURN TO OPENING MENU     
echo                                                    
echo          ͼ

echo 
echo [22;2HĿ
echo    PRESS Alt-F3 FOR HELP
echo [23;29H[1;41;37m3   [1;37;42m   
echo  

:go9
getchar
if errorlevel 88 if not errorlevel 89 goto go5
if errorlevel 120 if not errorlevel 121 goto go5
goto go9



:com
echo [1;37;44m
cls
echo 

echo          ͻ
echo            Inscrutable Program   V1.0  Comms menu  
echo          ͼ
echo 
echo 
echo 

echo                   ͻ
echo                     Comms functions menu  
echo                   ͼ
echo 
echo 
echo 

echo          ͻ
echo                                                    
echo             PRESS X  TO RETURN TO OPENING MENU     
echo                                                    
echo          ͼ

echo 
echo [22;2HĿ
echo    PRESS Alt-F3 FOR HELP
echo [23;29H[1;42;30m5   [1;37;44m   
echo  

:go8
getchar
if errorlevel 88 if not errorlevel 89 goto go5
if errorlevel 120 if not errorlevel 121 goto go5
goto go8



:bud
echo [1;30;46m
cls
echo 

echo          ͻ
echo            Inscrutable Program   V1.0  Budget menu  
echo          ͼ
echo 
echo 
echo 

echo                   ͻ
echo                     Budget functions menu  
echo                   ͼ
echo 
echo 
echo 

echo          ͻ
echo                                                    
echo             PRESS X  TO RETURN TO OPENING MENU     
echo                                                    
echo          ͼ

echo 
echo [22;2HĿ
echo    PRESS Alt-F3 FOR HELP
echo [23;29H[5;41;37m4   [0;30;46m   
echo  

:go10
getchar
if errorlevel 88 if not errorlevel 89 goto go5
if errorlevel 120 if not errorlevel 121 goto go5
goto go10


:go6
echo [1;37;44m
echo [2J
echo 
echo I hope that you can see the possibilities for integrating HELPEM with
echo your own programs, study this batch file using DOS TYPE to see how
echo simple this is. By writing a suitable batch file you could allow
echo the user to load HELPEM, adjusting the help level by using alternative
echo help files for different levels of experience, the batch
echo file would then execute your program

echo 
echo There is no reason why two or more copies of HELPEM cannot be
echo active at the same time, after all each one only occupies just
echo under 30K of memory. Each copy would be installed with its own
echo hot-zone, a separate help file, and a different Function key.
echo 
echo This exactly what we shall show next, press any key to
echo see the installation of a second HELPEM system.

getchar
demo2.bat
:end
