/*==============================================================*/
/* K E Y B O A R D                                              */
/*                                                              */
/* KBD   Version 2.1   Colin J Smith (c) March 1990             */
/*                                                              */
/* A program to set the keyboard rate and delay on AT-style     */
/* (84 key) & Enhanced-style (101/102-key) keyboards.           */
/*                                                              */
/* Written in Turbo C V1.5 (c) Borland International            */
/*==============================================================*/

#include <stdio.h>
#include <bios.h>
#include <dos.h>

main(int argc, char *argv[])
{
    int rate, delay;
    union REGS iregs, oregs;

    if(argc != 3)
        notail();           /* finish if not enough arguments   */

    rate = atoi(argv[1]);
    delay = atoi(argv[2]);

    if(rate < 1 || rate > 32 || delay < 1 || delay > 4)
        notail();           /* finish if arguments invalid      */

    iregs.h.bl = --rate;    /* set keyboard repeat rate         */
    iregs.h.bh = --delay;   /* set keyboard delay before repeat */
    iregs.h.al = 5;
    iregs.h.ah = 3;
    int86(0x16, &iregs, &oregs);  /* call func set rate & delay */
}

/*==============================================================*/

notail(void)
{
    printf("\nKBD Ver 2.1 (c) Colin J Smith March \'90\n");
    printf("Usage: KBD r d -- set keyboard repeat rate and delay\n\n");
    printf("rRaterRaterRatedDelayĿ\n");
    printf("                                                    \n");
    printf("   1 - 30.0   12 - 10.9   23 -  4.3      1 -  250   \n");
    printf("   2 - 26.7   13 - 10.0   24 -  4.0      2 -  500   \n");
    printf("   3 - 24.0   14 -  9.2   25 -  3.7      3 -  750   \n");
    printf("   4 - 21.8   15 -  8.6   26 -  3.3      4 - 1000   \n");
    printf("   5 - 20.0   16 -  8.0   27 -  3.0                 \n");
    printf("   6 - 18.5   17 -  7.5   28 -  2.7                 \n");
    printf("   7 - 17.1   18 -  6.7   29 -  2.5                 \n");
    printf("   8 - 16.0   19 -  6.0   30 -  2.3                 \n");
    printf("   9 - 15.0   20 -  5.5   31 -  2.1                 \n");
    printf("  10 - 13.3   21 -  5.0   32 -  2.0                 \n");
    printf("  11 - 12.0   22 -  4.6                             \n");
    printf("                                                    \n");
    printf("        characters per second          milliseconds \n");
    printf("\n");
    printf("For old AT-style (84 key) or Enhanced (101/102 key) keyboards ONLY!\n");
    exit(-1);
}

/*==============================================================*/
