/*==============================================================*/
/* L O C K   K E Y   S T A T U S                                */
/*                                                              */
/* LKSTAT   Version 2.1   Colin J Smith (c) March 1990          */
/*                                                              */
/* A program to read/set the shift key status                   */
/*                                                              */
/* Written in Turbo C V1.5 (c) Borland International            */
/*==============================================================*/

#include <dos.h>

#define KSTAT ((int far *)(0x417L))

main(int argc, char *argv[])
{
    int fnum, snum, lkstat, result;
    int far *fp;

    fp = KSTAT;                       /* initialise far pointer */

    if (argc != 3 && argc != 2)
        notail();

    fnum = atoi(argv[1]);
    snum = atoi(argv[2]);

    if (fnum < 1 || fnum > 4 || snum > 1 || snum < 0)
        notail();

    lkstat = *fp;               /* get status byte at 0000:0417 */

    result = lkstat >> (8 - fnum);   /* shift status bit to end */

    if (argc == 3 && snum == 1)
        switch (fnum)
        {
            case 1: *fp = *fp | 0x80;    /* set insert bit      */
                    break;

            case 2: *fp = *fp | 0x40;    /* set caps lock bit   */
                    break;

            case 3: *fp = *fp | 0x20;    /* set num lock bit    */
                    break;

            case 4: *fp = *fp | 0x01;    /* set scroll lock bit */
                    break;
        }

    if (argc == 3 && snum == 0)
        switch (fnum)
        {
            case 1: *fp = *fp & 0x7f;  /* reset insert bit      */
                    break;

            case 2: *fp = *fp & 0xbf;  /* reset caps lock bit   */
                    break;

            case 3: *fp = *fp & 0xdf;  /* reset num lock bit    */
                    break;

            case 4: *fp = *fp & 0xef;  /* reset scroll lock bit */
                    break;
        }

    result = result & 1;          /* mask off status bit        */
    exit(result);                 /* return value to ERRORLEVEL */
}

/*==============================================================*/

notail(void)
{
    printf("\nLKSTAT Ver 2.1 (c) Colin J Smith March \'90\n");
    printf("Usage: LKSTAT k   -- [1] get status of key lock 'k'\n");
    printf("       LKSTAT k s -- set status of key lock 'k' to 's'\n\n");
    printf("kKEYsSTATUSĿ\n");
    printf("                                                      \n");
    printf("                 1 Insert    0 Lock OFF               \n");
    printf("                 2 Caps      1 Lock ON                \n");
    printf("                 3 Num                                \n");
    printf("                 4 Scroll                             \n");
    printf("                                                      \n");
    printf("ERRORLEVEL returnsĴ\n");
    printf("[1]       getting status of key lock k        \n");
    printf("  0 - key NOT locked                  1 - key locked  \n");
    printf("\n");
    exit(-1);
}

/*==============================================================*/
