; NO386.ASM - put the high bit of the FLAGS register into the low bit of AX
; Copyright (C) 1987 Richard V. Robinson

; According to Intel's 80386 Programmer's Reference Manual, p. 14-7,
;
;	The setting of the flags stored by PUSHF...is different
;	from that stored by the 8086 in bit positions 12 through 15.
;	On the 8086 these bits are stored as ones, but in 80386 real-
;	address mode bit 15 is always zero, and bits 14 through 12
;	reflect the last value loaded into them.
;
; This routine merely loads bit 15 of FLAGS into AX, and would therefore
; more appropriately be called "IS8086."  I have not found a way for
; software to distinguish between an 80286 and an 80386.  When I do,
; I'll incorporate it here, and this routine will live up to its name.

	public  _no386

_text	segment word public 'code'
	assume  cs:_text

_no386	proc    near

	pushf
	pop	ax

	rol	ax,1
	and	ax,1

	ret

_no386	endp

_text	ends
	end
