;=================================================================
;
; S E T   V I D E O   M O D E
;
; SETMODE   Version 2.1   Colin J Smith (c) March 1990
;
; A program to change the graphics mode more easily
;
; SYNTAX:
;               SETMODE mode
;
; where mode is the graphics mode between 0 - 7
;
;=================================================================

first:  mov cl,b[080]            ; find length of command tail
        cmp cl,2                 ; does a tail exist?
        jb notail                ; exit if there is no tail

        mov al,b[082]
        sub al,48                ; find value of mode chosen
        mov bl,0                 ; check if value is between 0 - 7
next:   cmp al,bl
        jz set                   ; jump if 'mode' is valid
        inc bl
        cmp bl,8
        jb next

                                 ; mode was invalid, so remind syntax
notail: mov ah,09                ; specify function, print a message
        mov dx,message           ; give location of message to print
        int 021h                 ; call routine to perform function
        mov al,255               ; get ready to exit
        jmp exit

set:    mov ah,0                 ; specify function - to set mode
        int 010h                 ; call function to set mode

exit:   mov ah,04ch              ; specify function, exit
        int 021h                 ; call routine to perform function

;=================================================================
; Message
;=================================================================

message: db 0D,0A,'SETMODE Ver 2.1 (c) Colin J Smith March ',39,'90',0D,0A
         db 'Usage: SETMODE m -- sets video mode to m',0D,0A,0D,0A
	 db 'mMODEĿ',0D,0A
	 db '                                       ',0D,0A
	 db '  0  CGA   40 x 25  B/W    [Text]      ',0D,0A
	 db '  1  CGA   40 x 25  COLOUR [Text]      ',0D,0A
	 db '  2  CGA   80 x 25  B/W    [Text]      ',0D,0A
	 db '  3  CGA   80 x 25  B/W    [Text]      ',0D,0A
	 db '  4  CGA  320 x 200 COLOUR [Graphics]  ',0D,0A
	 db '  5  CGA  320 x 320 B/W    [Graphics]  ',0D,0A
	 db '  6  CGA  640 x 200 B/W    [Graphics]  ',0D,0A
	 db '  7  MONO  80 x 35  B/W    [Text]      ',0D,0A
	 db '                                       ',0D,0A
         db '',0D,0A
         db '$'

;=================================================================

