/*==============================================================*/
/* S O U N D   M A C H I N E                                    */
/*                                                              */
/* SM   Version 2.1   Colin J Smith (c) March 1990              */
/*                                                              */
/* A program to select 'Personal Computer Sounds'               */
/*                                                              */
/* Written in Turbo C V1.5 (c) Borland International            */
/*==============================================================*/

#define TIMERMODE 182
#define FREQSCALE 1190000L
#define T_MODEPORT 67
#define FREQPORT 66
#define BEEPPORT 97                 /* speaker port             */
#define ON 79                       /* byte to activate speaker */

#define C 262                       /* note frequencies         */
#define E 330                       /* measured in Hz           */

#include <dos.h>

main(int argc, char *argv[])
{
    int slug, randno1, randno2;
    int fnum;

    fnum = atoi(argv[1]);

    if (argc < 2 || fnum == 0)
        notail();

    do
    {
        switch (fnum)
        {
            case 1: for (slug = 100; slug < 110; slug++)
                        beep(C, 1000);
                    break;

            case 2: for (slug = 100; slug < 150; slug++)
                        beep(C, slug*3);
                    break;

            case 3: for (slug = 150; slug > 100; slug--)
                        beep(C, slug*3);
                    break;

            case 4: for (slug = 100; slug < 150; slug++)
                        beep(slug, 1000);
                    break;

            case 5: for (slug = 100; slug < 150; slug++)
                    {
                        beep(slug, 3, 1000);
                        beep(300 - slug, 1000);
                    }
                    break;

            case 6: for (slug = 1; slug < 3; slug++)
                    {
                        for (randno1 = 1; randno1 < 3; randno1++)
                            beep(C, 500);
                        for (randno2=3; randno2 > 1; randno2--)
                            beep(E, 500);
                    }
                    break;

            case 7: for (slug = 100; slug < 140; slug++)
                        beep(slug*2, 1000);
                    break;

            case 8: for (slug = 100; slug < 200; slug++)
                    {
                        randno1 = pull(260, 500);
                        beep(randno1, 900);
                    }
                    break;

            case 9: break;      /* you can add more sounds here */

           default: break;      /* right past 99+ - good luck   */
        }

    } while (!kbhit());

    getch();
}

/*==============================================================*/

beep(int freq, int tcycle)
{
    int msbyt, lsbyt, port;
    long rest, divis;

    divis = FREQSCALE / freq;  /* scale frequency for port      */
    lsbyt = divis % 256;       /* find least significant byte   */
    msbyt = divis / 256;       /* find most signigicant byte    */

    outp(T_MODEPORT, TIMERMODE);
    outp(T_MODEPORT, TIMERMODE);
    outp(FREQPORT, lsbyt);     /* load port with lsb of freq    */
    outp(FREQPORT, msbyt);     /* load port with msb of freq    */
    port = inp(BEEPPORT);      /* save contents of speaker port */
    outp(BEEPPORT, ON);        /* activate speaker              */

                               /* do nothing for a while        */
    for (rest = 0; rest < tcycle; rest++)
        ;

    outp(BEEPPORT, port);
}

/*==============================================================*/

notail(void)
{
    printf("\nSM - Sound Machine Ver 2.1 (c) Colin J Smith March \'90\n");
    printf("Usage: SM n -- where 'n' is the sound\n\n");
    printf("nSOUNDĿ\n");
    printf("                        \n");
    printf("   1    Patter          \n");
    printf("   2    Burst Up        \n");
    printf("   3    Burst Down      \n");
    printf("   4    Reverb          \n");
    printf("   5    Lazy            \n");
    printf("   6    Alert           \n");
    printf("   7    Quick Alarm     \n");
    printf("   8    Random Chatter  \n");
    printf("   9    Golden          \n");
    printf("                        \n");
    printf("\n");
    exit(-1);
}

/*==============================================================*/

pull(int start, int finish)
{
    int pullno;

    do
    {
        pullno = rand();
    } while (pullno < finish && pullno > start);

    return (pullno);
}

/*==============================================================*/
