/*==============================================================*/
/* V I D E O   M O D E                                          */
/*                                                              */
/* VM   Version 2.1   Colin J Smith (c) March 1990              */
/*                                                              */
/* A program to manage the PC video display modes               */
/*                                                              */
/* Written in Turbo C V1.5 (c) Borland International            */
/*==============================================================*/

/* #define MSC5 :use this to compile in Microsoft C 5.0 or 5.1  */

#ifdef MSC5
    #include <graph.h>
#endif

#include <dos.h>

#define VIDEOINT 0x10               /* the video mode interrupt */

main(int argc, char *argv[])
{
    int fnum, snum;
    union REGS iregs, oregs;        /* define registers         */

    if (argc == 1)                           /* if no arguments */
        notail();                            /* display usage   */

    fnum = atoi(argv[1]);

#ifdef MSC5
    _setvideomode(fnum);
#else
    iregs.h.al = fnum;
    iregs.h.ah = 0;
    int86(VIDEOINT, &iregs, &oregs);
#endif

}

/*==============================================================*/

notail(void)
{
    printf("\nVM Ver 2.1 (c) Colin J Smith March \'90\n");
    printf("Usage: VM m -- sets video mode to m\n\n");
    printf("mADAPTRESOLUTIONSTYPECOLOURSDISPLAYĿ\n");
    printf("            ALPHASCREENCHARSĿ                                 \n");
    printf("   0   CGA   40 x 25   320 x 200   8 x 8      [Text]      16     [Colour]  \n");
    printf("   1   CGA   40 x 25   320 x 200   8 x 8      [Text]     16/8    [Colour]  \n");
    printf("   2   CGA   80 x 25   640 x 200   8 x 8      [Text]      16     [Colour]  \n");
    printf("   3   CGA   80 x 25   640 x 200   8 x 8      [Text]     16/8    [Colour]  \n");
    printf("   4   CGA   40 x 25   320 x 200   8 x 8    [Graphics]     4     [Colour]  \n");
    printf("   5   CGA   40 x 25   320 x 320   8 x 8    [Graphics]     4     [Colour]  \n");
    printf("   6   CGA   80 x 25   640 x 200   8 x 8    [Graphics]     2      [Mono]   \n");
    printf("   7   MDA   80 x 25   720 x 350   9 x 14     [Text]       1      [Mono]   \n");
    printf("  13   EGA   40 x 25   320 x 200   8 x 8    [Graphics]    16     [Colour]  \n");
    printf("  14   EGA   80 x 25   640 x 200   8 x 8    [Graphics]    16     [Colour]  \n");
    printf("  15   EGA   80 x 25   640 x 350   8 x 14   [Graphics]     1      [Mono]   \n");
    printf("  16   EGA   80 x 25   640 x 350   8 x 14   [Graphics]    16     [Colour]  \n");
    printf("  17   VGA   80 x 30   640 x 480   8 x 16   [Graphics]     2     [Colour]  \n");
    printf("  18   VGA   80 x 30   640 x 480   8 x 16   [Graphics]    16     [Colour]  \n");
    printf("  19   VGA   40 x 25   320 x 200   8 x 8    [Graphics]   256     [Colour]  \n");
    printf("                                             \n");
    printf("\n");
    exit(-1);
}

/*==============================================================*/
