;=================================================================
;
; Z Z A P
;
; ZZAP   Version 2.1   Colin J Smith (c) March 1990
;
; A program to produce a white noise sound - gradually decreasing
;
; SYNTAX: None
;
;=================================================================

first:  cli                     ; disable interrupts
again:  mov cx,02ffh

begin:  in al,97                ; save initial port status
        mov b[hold],al          ; save status byte
        mov al,79
        out 97,al               ; output to port
        mov dx,cx
        add dx,0fd00h

pause:  inc dx                  ; pause loop
        jnz pause
        mov al,b[hold]          ; restore port status byte
        out 97,al               ; output to port
        dec cx
        jnz begin
        sti                     ; enable interrupts

        mov dl,255              ; select keyboard routine
        mov ah,6
        int 021h                ; call key function
        jz again                ; if no key then loop

        int 020h                ; exit routine

hold:   db 0                    ; byte to hold initial port status

;=================================================================
