;=================================================================
;
; Z Z A P 1
;
; ZZAP1   Version 2.1   Colin J Smith (c) March 1990
;
; A program to produce a white noise sound - increasing
;
; SYNTAX: None
;
;=================================================================

first:  cli                     ; disable interrupts
again:  mov bx,1000

start:  mov cx,bx
begin:  in al,97                ; input port status byte
        mov b[hold],al          ; save port status byte
        mov al,79
        out 97,al               ; send signal to sound port
        mov dx,cx

rest:   dec dx                  ; first pause loop
        jnz rest
        mov al,b[hold]          ; restore port status byte
        out 97,al               ; ouput port status byte
        mov dx,cx

pause:  dec dx                  ; second pause loop
        jnz pause
        sub cx,100
        jnbe begin              ; loop first cycle
        sub bx,4
        jnbe start              ; loop second cycle
        sti                     ; enable interrupts

        mov dl,255              ; select keyboard routine
        mov ah,6
        int 021h                ; call key function
        jz again                ; if no key then loop

        int 020h                ; exit routine

hold:   db 0                    ; initial port status

;=================================================================
